/*!
 * node-rcon
 * Copyright(c) 2012 Justin Li <j-li.net>
 * MIT Licensed
 */
/// <reference types="node" />
import events from 'events';
/**
 * options:
 *   tcp - true for TCP, false for UDP (optional, default true)
 *   challenge - if using UDP, whether to use the challenge protocol (optional, default true)
 *   id - RCON id to use (optional)
 */
interface Options {
    tcp?: boolean;
    challenge?: boolean;
    id?: number;
}
export declare class Rcon extends events.EventEmitter {
    private host;
    private port;
    private password;
    private rconId;
    private hasAuthed;
    private outstandingData;
    private tcp;
    private challenge;
    private _challengeToken;
    private _tcpSocket;
    private _udpSocket;
    constructor(host: string, port: number, password: string, options: Options);
    send: (data: string, cmd: number, id?: number | undefined) => void;
    private _sendSocket;
    connect: () => void;
    disconnect: () => void;
    setTimeout: (timeout: number, callback: () => any) => void;
    private _udpSocketOnData;
    private _tcpSocketOnData;
    socketOnConnect: () => void;
    socketOnEnd: () => void;
}
export default Rcon;
